"""add entities

Revision ID: 67d35b181bbe
Revises: 
Create Date: 2022-04-30 17:04:26.438025

"""
from alembic import op
import sqlalchemy as sa


# revision identifiers, used by Alembic.
revision = '67d35b181bbe'
down_revision = None
branch_labels = None
depends_on = None


def upgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.create_table('timeseries',
    sa.Column('id', sa.BigInteger(), autoincrement=True, nullable=False),
    sa.Column('name', sa.String(length=512), nullable=False),
    sa.Column('created_at', sa.DateTime(), nullable=True),
    sa.Column('updated_at', sa.DateTime(), nullable=True),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_table('point',
    sa.Column('id', sa.BigInteger(), autoincrement=True, nullable=False),
    sa.Column('timeseries_id', sa.BigInteger(), nullable=False),
    sa.Column('name', sa.String(length=32), nullable=False),
    sa.Column('marked', sa.Boolean(), nullable=False),
    sa.Column('value', sa.Float(), nullable=False),
    sa.Column('index', sa.Integer(), nullable=False),
    sa.Column('created_at', sa.DateTime(), nullable=True),
    sa.Column('updated_at', sa.DateTime(), nullable=True),
    sa.ForeignKeyConstraint(['timeseries_id'], ['timeseries.id'], ),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_index('point_unique_timeseries_id_index', 'point', ['timeseries_id', 'index'], unique=True)
    op.create_index('point_unique_timeseries_marked_point_name', 'point', ['timeseries_id', 'name'], unique=True, postgresql_where=sa.text('marked IS true'))
    op.create_table('value',
    sa.Column('id', sa.BigInteger(), autoincrement=True, nullable=False),
    sa.Column('timeseries_id', sa.BigInteger(), nullable=False),
    sa.Column('name', sa.String(length=32), nullable=False),
    sa.Column('expr', sa.String(length=512), nullable=False),
    sa.Column('value', sa.Float(), nullable=False),
    sa.Column('created_at', sa.DateTime(), nullable=True),
    sa.Column('updated_at', sa.DateTime(), nullable=True),
    sa.ForeignKeyConstraint(['timeseries_id'], ['timeseries.id'], ),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_index('value_unique_timeseries_marked_value_name', 'value', ['timeseries_id', 'name'], unique=True)
    # ### end Alembic commands ###


def downgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_index('value_unique_timeseries_marked_value_name', table_name='value')
    op.drop_table('value')
    op.drop_index('point_unique_timeseries_marked_point_name', table_name='point', postgresql_where=sa.text('marked IS true'))
    op.drop_index('point_unique_timeseries_id_index', table_name='point')
    op.drop_table('point')
    op.drop_table('timeseries')
    # ### end Alembic commands ###
